package cn.com.ctop.kuaishou.modules.batch.controller;

import cn.com.ctop.common.module.utils.Check;
import cn.com.ctop.kuaishou.modules.batch.entity.KuaishouBatchCreativePreview;
import cn.com.ctop.kuaishou.modules.batch.entity.KuaishouBatchGroupPreview;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaishouBatchCreativePreviewService;
import cn.com.ctop.kuaishou.modules.batch.service.IKuaishouBatchGroupPreviewService;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 快手-广告组预览信息
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2021-01-26
 */
@Slf4j
@Api(tags = "快手-广告组预览信息")
@RestController
@RequestMapping("/kuaishouBatch/groupPreview")
public class KuaishouBatchGroupPreviewController {
    @Autowired
    private IKuaishouBatchGroupPreviewService kuaishouBatchGroupPreviewService;
    @Autowired
    private IKuaishouBatchCreativePreviewService kuaishouBatchCreativePreview;

    /**
     * 分页列表查询
     *
     * @param kuaishouBatchGroupPreview
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @AutoLog(value = "快手-广告组预览信息-分页列表查询")
    @ApiOperation(value = "快手-广告组预览信息-分页列表查询", notes = "快手-广告组预览信息-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<KuaishouBatchGroupPreview>> queryPageList(KuaishouBatchGroupPreview kuaishouBatchGroupPreview,
                                                                  @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                                  @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                                  HttpServletRequest req) {
        Result<IPage<KuaishouBatchGroupPreview>> result = new Result<>();
        String statDate = kuaishouBatchGroupPreview.getStatDate();
        kuaishouBatchGroupPreview.setStatDate(null);
        QueryWrapper<KuaishouBatchGroupPreview> queryWrapper = QueryGenerator.initQueryWrapper(kuaishouBatchGroupPreview, req.getParameterMap());
        if (!Check.isNull(statDate)) {
            queryWrapper.like("create_time", statDate);
        }
        queryWrapper.orderByDesc("create_time");
        Page<KuaishouBatchGroupPreview> page = new Page<KuaishouBatchGroupPreview>(pageNo, pageSize);
        IPage<KuaishouBatchGroupPreview> pageList = kuaishouBatchGroupPreviewService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     *
     * @param kuaishouBatchGroupPreview
     * @return
     */
    @AutoLog(value = "快手-广告组预览信息-添加")
    @ApiOperation(value = "快手-广告组预览信息-添加", notes = "快手-广告组预览信息-添加")
    @PostMapping(value = "/add")
    public Result<KuaishouBatchGroupPreview> add(@RequestBody KuaishouBatchGroupPreview kuaishouBatchGroupPreview) {
        Result<KuaishouBatchGroupPreview> result = new Result<>();
        try {
            kuaishouBatchGroupPreviewService.save(kuaishouBatchGroupPreview);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 批量修改
     *
     * @return
     */
    @AutoLog(value = "快手-批量修改")
    @ApiOperation(value = "快手-批量修改", notes = "快手-批量修改")
    @PostMapping(value = "/batchEdit")
    public Result<Object> batchEdit(@RequestBody JSONObject data) {
        try {
            return kuaishouBatchGroupPreviewService.batchEdit(data);
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            Result.error("操作失败");
        }
        return Result.error("修改失败");
    }

    /**
     * 编辑
     *
     * @param kuaishouBatchGroupPreview
     * @return
     */
    @AutoLog(value = "快手-广告组预览信息-编辑")
    @ApiOperation(value = "快手-广告组预览信息-编辑", notes = "快手-广告组预览信息-编辑")
    @PostMapping(value = "/edit")
    public Result<KuaishouBatchGroupPreview> edit(@RequestBody KuaishouBatchGroupPreview kuaishouBatchGroupPreview) {
        Result<KuaishouBatchGroupPreview> result = new Result<KuaishouBatchGroupPreview>();
        try {
            KuaishouBatchGroupPreview kuaishouBatchGroupPreviewEntity = kuaishouBatchGroupPreviewService.getById(kuaishouBatchGroupPreview.getId());
            if (kuaishouBatchGroupPreviewEntity == null) {
                result.error500("未找到对应实体");
            } else {
                boolean ok = kuaishouBatchGroupPreviewService.updateById(kuaishouBatchGroupPreview);
                if (!Check.isNull(kuaishouBatchGroupPreview.getClickTrackUrl()) || !Check.isNull(kuaishouBatchGroupPreview.getSiteId()) || !Check.isNull(kuaishouBatchGroupPreview.getActionbarClickUrl())) {
                    KuaishouBatchCreativePreview creative = new KuaishouBatchCreativePreview();
                    creative.setClickTrackUrl(kuaishouBatchGroupPreview.getClickTrackUrl());
                    creative.setSiteId(kuaishouBatchGroupPreview.getSiteId());
                    creative.setActionbarClickUrl(kuaishouBatchGroupPreview.getActionbarClickUrl());
                    QueryWrapper<KuaishouBatchCreativePreview> wrapper = new QueryWrapper<>();
                    wrapper.eq("group_id", kuaishouBatchGroupPreview.getId());
                    kuaishouBatchCreativePreview.update(creative, wrapper);
                }
                if (ok) {
                    result.success("修改成功!");
                }
            }
        } catch (Exception e) {
            log.error("修改异常", e);
            result.error500("修改失败");
        }
        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "快手-广告组预览信息-通过id删除")
    @ApiOperation(value = "快手-广告组预览信息-通过id删除", notes = "快手-广告组预览信息-通过id删除")
    @RequestMapping(value = "/delete")
    public Result<?> delete(@RequestParam(name = "id", required = true) String id) {
        try {
            kuaishouBatchGroupPreviewService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "快手-广告组预览信息-批量删除")
    @ApiOperation(value = "快手-广告组预览信息-批量删除", notes = "快手-广告组预览信息-批量删除")
    @RequestMapping(value = "/deleteBatch")
    public Result<KuaishouBatchGroupPreview> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<KuaishouBatchGroupPreview> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.kuaishouBatchGroupPreviewService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @AutoLog(value = "快手-广告组预览信息-通过id查询")
    @ApiOperation(value = "快手-广告组预览信息-通过id查询", notes = "快手-广告组预览信息-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<KuaishouBatchGroupPreview> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<KuaishouBatchGroupPreview> result = new Result<>();
        KuaishouBatchGroupPreview kuaishouBatchGroupPreview = kuaishouBatchGroupPreviewService.getById(id);
        if (kuaishouBatchGroupPreview == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(kuaishouBatchGroupPreview);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        // Step.1 组装查询条件
        QueryWrapper<KuaishouBatchGroupPreview> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                KuaishouBatchGroupPreview kuaishouBatchGroupPreview = JSON.parseObject(deString, KuaishouBatchGroupPreview.class);
                queryWrapper = QueryGenerator.initQueryWrapper(kuaishouBatchGroupPreview, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<KuaishouBatchGroupPreview> pageList = kuaishouBatchGroupPreviewService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "快手-广告组预览信息列表");
        mv.addObject(NormalExcelConstants.CLASS, KuaishouBatchGroupPreview.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("快手-广告组预览信息列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<KuaishouBatchGroupPreview> listKuaishouBatchGroupPreviews = ExcelImportUtil.importExcel(file.getInputStream(), KuaishouBatchGroupPreview.class, params);
                kuaishouBatchGroupPreviewService.saveBatch(listKuaishouBatchGroupPreviews);
                return Result.ok("文件导入成功！数据行数:" + listKuaishouBatchGroupPreviews.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}
